﻿using Microsoft.VisualStudio.TestTools.WebTesting;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Benday.WebLoadTest.Utilities
{
    [DisplayName("Does String Exist In Response")]
    [Description("Looks in the response for a string and sets true/false into context.")]
    public class ExtractResponseContainsString : ExtractionRule
    {
        [DisplayName("Search string")]
        [Description("String to search for")]
        public string SearchString { get; set; }

        public override void Extract(object sender, ExtractionEventArgs e)
        {
            if (String.IsNullOrWhiteSpace(SearchString) == true)
            {
                Fail(e, "The search string value is invalid.");
            }
            else
            {
                if (e.Response.BodyString.Contains(SearchString) == true)
                {
                    e.WebTest.Context.Add(ContextParameterName, "true");
                    e.Success = true;
                }
                else
                {
                    e.WebTest.Context.Add(ContextParameterName, "false");
                    e.Success = true;
                }
            }
        }

        private void Fail(ExtractionEventArgs e, string message)
        {
            e.Success = false;
            e.Message = message;
        }
    }
}
